diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index fceddd6cd..4fe6b586e 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -1,7 +1,13 @@
 package net.minecraft.core.block;
 
 
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
+
 import com.b100.utils.Utils;
+
 import net.minecraft.core.HitResult;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.TileEntity;
@@ -43,11 +49,6 @@ import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Random;
-
 public class Block
     implements ITaggable<Block>, IItemConvertible
 {
@@ -781,6 +782,8 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block slatePolished = new Block("slate.polished", 864, Material.stone).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block permafrostPolished = new Block("permafrost.polished", 865, Material.stone).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block pillarMarble = new BlockAxisAligned("pillar.marble", 20, Material.stone).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -798,6 +801,8 @@ public class Block
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block basaltCarved = new Block("basalt.carved", 43, Material.stone).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block permafrostCarved = new Block("permafrost.carved", 44, Material.stone).withHardness(2.0F).withBlastResistance(10F)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block planksOak = new Block("planks.oak", 50, Material.wood).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
@@ -928,6 +933,14 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block stairsBrickStone = new BlockStairs(brickStone, 173).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block stairsSandstone = new BlockStairs(sandstone, 174).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block stairsBrickSandstone = new BlockStairs(brickSandstone, 175).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block stairsCobblePermafrost = new BlockStairs(cobblePermafrost, 176).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block stairsBrickPermafrost = new BlockStairs(Block.brickPermafrost, 177).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block obsidian = new Block("obsidian", 180, Material.stone).withHardness(10F).withBlastResistance(2000F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1022,9 +1035,9 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
     public static final Block leavesCacao = new BlockLeavesCacao("leaves.cacao", 298).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
-    public static final Block leavesCaatinga = new BlockLeavesThorn("leaves.caatinga", 299).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block leavesThorn = new BlockLeavesThorn("leaves.thorn", 299).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
-    public static final Block leavesPalm = new BlockLeavesThorn("leaves.palm", 300).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block leavesPalm = new BlockLeavesPalm("leaves.palm", 300).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
 
 
@@ -1411,6 +1424,15 @@ public class Block
     public static final Block paperWall = new Block("paper_wall", 910, Material.cloth).withHardness(0.7F)
             .withTags(BlockTags.MINEABLE_BY_SHEARS, BlockTags.FENCES_CONNECT, BlockTags.CAN_HANG_OFF, BlockTags.MINEABLE_BY_AXE);
 
+    public static final Block slabBrickSandstone = new BlockSlab(Block.brickSandstone, 1000).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block slabCobblePermafrost = new BlockSlab(cobblePermafrost, 1001).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block slabBrickPermafrost = new BlockSlab(brickPermafrost, 1002).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block slabPermafrostPolished = new BlockSlab(permafrostCarved, 1003).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+
 
     public int[] atlasIndices = new int[6];
     public final int id;
@@ -1472,13 +1494,6 @@ public class Block
         Item.itemsList[layerLeavesOak.id] = new ItemBlockLayerLeaves(layerLeavesOak);
         Item.itemsList[ladderOak.id] = new ItemBlockLadder((BlockLadder) ladderOak);
 
-        for (int i = slabPlanksOak.id; i <= slabBasaltPolished.id; i++)
-        {
-        	if (blocksList[i] != null && i != slabPlanksOakPainted.id)
-        	{
-        		Item.itemsList[i] = new ItemBlockSlab(blocksList[i]);
-        	}
-        }
         Item.itemsList[slabPlanksOakPainted.id] = new ItemBlockSlabPainted(slabPlanksOakPainted);
         Item.itemsList[stairsPlanksOakPainted.id] = new ItemBlockStairsPainted(stairsPlanksOakPainted);
 
@@ -1494,6 +1509,10 @@ public class Block
                 {
                     Item.itemsList[i] = new ItemBlockLayer(blocksList[i]);
                 }
+                else if (blocksList[i] instanceof BlockSlab)
+                {
+                    Item.itemsList[i] = new ItemBlockSlab(blocksList[i]);
+                }
                 else
                 {
                     Item.itemsList[i] = new ItemBlock(blocksList[i]);
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
index 8e0b0207d..c28493488 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
@@ -49,6 +49,9 @@ public abstract class BlockLeavesBase extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
+    	if(!enableDecay) {
+    		return;
+    	}
         int radius = 1;
         int chunkRadius = radius + 1;
         if(world.areBlocksLoaded(x - chunkRadius, y - chunkRadius, z - chunkRadius, x + chunkRadius,
@@ -64,9 +67,9 @@ public abstract class BlockLeavesBase extends Block
                         if(Block.blocksList[blockId] instanceof BlockLeavesBase)
                         {
                             int meta = world.getBlockMetadata(x + dx, y + dy, z + dz);
-                            if ((meta & 1) == 0)
+                            if (!isPermanent(meta))
                             {
-                                world.setBlockMetadata(x + dx, y + dy, z + dz, meta | 8);
+                                world.setBlockMetadata(x + dx, y + dy, z + dz, setDecaying(meta, true));
                             }
                         }
                     }
@@ -82,7 +85,7 @@ public abstract class BlockLeavesBase extends Block
             return;
         }
         int meta = world.getBlockMetadata(x, y, z);
-        if((meta & 0x08) != 0 && !isPermanent(meta))
+        if(isDecaying(meta) && !isPermanent(meta))
         {
             byte byte0 = 4;
             int offset = byte0 + 1;
@@ -168,7 +171,7 @@ public abstract class BlockLeavesBase extends Block
             int j2 = adjacentTreeBlocks[halfLength * xSpan + halfLength * ySpan + halfLength];
             if(j2 >= 0)
             {
-                world.setBlockMetadata(x, y, z, meta & -9);
+                world.setBlockMetadata(x, y, z, setDecaying(meta, false));
             } else
             {
                 removeLeaves(world, x, y, z);
@@ -183,7 +186,19 @@ public abstract class BlockLeavesBase extends Block
     }
 
     public static boolean isPermanent(int meta) {
-    	return (meta & 0b1) > 0;
+    	return (meta & 1) != 0;
+    }
+    
+    public static boolean isDecaying(int meta) {
+    	return (meta & 8) != 0;
+    }
+    
+    public static int setDecaying(int meta, boolean decaying) {
+    	if(decaying) {
+    		return meta | 8;
+    	}else {
+    		return meta & ~8;
+    	}
     }
     
     @Override
@@ -192,5 +207,6 @@ public abstract class BlockLeavesBase extends Block
     }
 
     public static boolean enableTreeShadowing = false;
+    public static boolean enableDecay = true;
     int[] adjacentTreeBlocks;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java b/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
index 06ce81f86..2ebaca07b 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesPalm.java
@@ -4,8 +4,8 @@ import net.minecraft.core.block.material.Material;
 
 public class BlockLeavesPalm extends BlockLeavesBase {
 
-	public BlockLeavesPalm(String key, int id, Material material) {
-		super(key, id, material);
+	public BlockLeavesPalm(String key, int id) {
+		super(key, id, Material.leaves);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java b/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
index 1f08fd772..84f5e824b 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
@@ -3,7 +3,6 @@ package net.minecraft.core.block;
 import java.util.Random;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 
 public class BlockSaplingPalm extends BlockSaplingBase {
@@ -11,20 +10,14 @@ public class BlockSaplingPalm extends BlockSaplingBase {
 	public BlockSaplingPalm(String key, int id) {
 		super(key, id);
 		
-		canGrowOnSand = true;
+		this.canGrowOnSand = true;
 	}
 	
 	@Override
 	public void growTree(World world, int x, int y, int z, Random random) {
-		int blockBelow = world.getBlockId(x, y - 1, z);
-		
-    	boolean big = blockBelow != Block.sand.id;
-    	WorldFeature worldFeature = new WorldFeatureTreePalm(Block.logPalm, Block.leavesPalm, big, true);
+    	boolean big = world.getBlockId(x, y - 1, z) != Block.sand.id;
     	
-    	world.setBlock(x, y, z, 0);
-    	if(!worldFeature.generate(world, random, x, y, z)) {
-    		world.setBlock(x, y, z, id);
-    	}
+    	new WorldFeatureTreePalm(Block.logPalm, Block.leavesPalm, big, true).generate(world, random, x, y, z);
 	}
 
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
index 307cd47f4..a0006e8ed 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
@@ -21,7 +21,7 @@ public class BlockSaplingThorn extends BlockSaplingBase
         WorldFeature treeFeature = null;
 
         world.setBlock(x, y, z, 0);
-        treeFeature = new WorldFeatureTreeThorn(1, Block.logThorn.id, 0, Block.leavesCaatinga.id, 0);
+        treeFeature = new WorldFeatureTreeThorn(1, Block.logThorn.id, 0, Block.leavesThorn.id, 0);
 
         if(!treeFeature.generate(world, random, x, y, z))
         {
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index 15162a7e5..939c74685 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -1,11 +1,10 @@
 package net.minecraft.core.block.entity;
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumSignPicture;
-import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet130UpdateSign;
 import net.minecraft.core.net.packet.Packet140TileEntityData;
 
 public class TileEntitySign extends TileEntity
@@ -48,7 +47,7 @@ public class TileEntitySign extends TileEntity
     
     public boolean getIsEditable(EntityPlayer player)
     {
-        return player.username.equals(owner) || owner.isEmpty();
+        return player.username.equals(owner);
     }
     public void setOwner(EntityPlayer player){
         this.owner = player.username;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 442b983f5..2c616ad98 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -1,10 +1,15 @@
 package net.minecraft.core.data.registry.recipe.adapter;
 
-import com.google.gson.*;
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.command.commands.GiveCommand;
 
 import java.lang.reflect.Type;
 
@@ -26,7 +31,7 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
                 }
             } catch (Exception e){
                 System.out.println("Failed to find item for key '" + key + "'!");
-                throw e;
+                throw new IllegalArgumentException("Failed to find item for key '" + key + "'!\n" + e.getMessage());
             }
         } else {
             item = Item.itemsList[obj.get("id").getAsInt()];
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java b/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
index ccd871241..434fda998 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
@@ -437,7 +437,9 @@ public class EntityFireflyCluster extends EntityFlying
 		public static FireflyColor ORANGE = register(new FireflyColor(1, "fireflyOrange", new Biome[] {
 				Biomes.OVERWORLD_DESERT,
 				Biomes.OVERWORLD_OUTBACK,
-				Biomes.OVERWORLD_OUTBACK_GRASSY
+				Biomes.OVERWORLD_OUTBACK_GRASSY,
+				Biomes.OVERWORLD_CAATINGA,
+				Biomes.OVERWORLD_CAATINGA_PLAINS,
 		},
 				new float[]{1f, 0.9f, 0.58f}));
 		public static FireflyColor BLUE = register(new FireflyColor(2, "fireflyBlue", new Biome[] {
diff --git a/src/main/java/net/minecraft/core/item/ItemSign.java b/src/main/java/net/minecraft/core/item/ItemSign.java
index be7ae04ea..6cfd7192b 100644
--- a/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -58,7 +58,7 @@ public class ItemSign extends Item
         }
         itemstack.consumeItem(entityplayer);
         TileEntitySign tileentitysign = (TileEntitySign)world.getBlockTileEntity(blockX, blockY, blockZ);
-        if(tileentitysign != null && tileentitysign.getIsEditable(entityplayer))
+        if(tileentitysign != null)
         {
             tileentitysign.setOwner(entityplayer);
             entityplayer.displayGUIEditSign(tileentitysign);
diff --git a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
index 0bb356b3c..f04e8a360 100644
--- a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
+++ b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
@@ -35,6 +35,7 @@ public class BlockSoundDispatcher
         addDispatch(Block.limestonePolished, BlockSounds.STONE);
         addDispatch(Block.basaltPolished, BlockSounds.STONE);
         addDispatch(Block.slatePolished, BlockSounds.STONE);
+        addDispatch(Block.permafrostPolished, BlockSounds.STONE);
 
         addDispatch(Block.pillarMarble, BlockSounds.STONE);
         addDispatch(Block.capstoneMarble, BlockSounds.STONE);
@@ -45,6 +46,7 @@ public class BlockSoundDispatcher
         addDispatch(Block.graniteCarved, BlockSounds.STONE);
         addDispatch(Block.limestoneCarved, BlockSounds.STONE);
         addDispatch(Block.basaltCarved, BlockSounds.STONE);
+        addDispatch(Block.permafrostCarved, BlockSounds.STONE);
 
         addDispatch(Block.planksOak, BlockSounds.WOOD);
         addDispatch(Block.planksOakPainted, BlockSounds.WOOD);
@@ -100,6 +102,10 @@ public class BlockSoundDispatcher
         addDispatch(Block.slabGranitePolished, BlockSounds.STONE);
         addDispatch(Block.slabLimestonePolished, BlockSounds.STONE);
         addDispatch(Block.slabBasaltPolished, BlockSounds.STONE);
+        addDispatch(Block.slabPermafrostPolished, BlockSounds.STONE);
+        addDispatch(Block.slabCobblePermafrost, BlockSounds.STONE);
+        addDispatch(Block.slabBrickSandstone, BlockSounds.STONE);
+        addDispatch(Block.slabBrickPermafrost, BlockSounds.STONE);
 
         addDispatch(Block.stairsPlanksOak, BlockSounds.WOOD);
         addDispatch(Block.stairsCobbleStone, BlockSounds.STONE);
@@ -115,6 +121,10 @@ public class BlockSoundDispatcher
         addDispatch(Block.stairsPlanksOakPainted, BlockSounds.WOOD);
         addDispatch(Block.stairsBrickSlate, BlockSounds.STONE);
         addDispatch(Block.stairsBrickStone, BlockSounds.STONE);
+        addDispatch(Block.stairsSandstone, BlockSounds.STONE);
+        addDispatch(Block.stairsCobblePermafrost, BlockSounds.STONE);
+        addDispatch(Block.stairsBrickSandstone, BlockSounds.STONE);
+        addDispatch(Block.stairsBrickPermafrost, BlockSounds.STONE);
 
         addDispatch(Block.obsidian, BlockSounds.STONE);
 
@@ -170,7 +180,7 @@ public class BlockSoundDispatcher
         addDispatch(Block.leavesShrub, BlockSounds.GRASS);
         addDispatch(Block.leavesCherryFlowering, BlockSounds.GRASS);
         addDispatch(Block.leavesCacao, BlockSounds.GRASS);
-        addDispatch(Block.leavesCaatinga, BlockSounds.GRASS);
+        addDispatch(Block.leavesThorn, BlockSounds.GRASS);
         addDispatch(Block.leavesPalm, BlockSounds.GRASS);
 
         addDispatch(Block.saplingOak, BlockSounds.GRASS);
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index f76962f25..56552794e 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -123,7 +123,7 @@ public class World implements WorldSource {
 
     public AuroraProvider auroraProvider;
 
-    private final SeasonManager seasonManager;
+    public final SeasonManager seasonManager;
 
     public final WeatherManager weatherManager;
 
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
index a91468a70..b83e37492 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
@@ -24,12 +24,12 @@ public class BiomeCaatinga extends Biome
     @Override
     public WorldFeature getRandomWorldGenForTrees(Random random)
     {
-        if(random.nextInt(5) != 0)
+        if(random.nextInt(3) != 0)
         {
-            return new WorldFeatureTreeShrub(Block.leavesCaatinga.id, Block.logOak.id);
+            return new WorldFeatureTreeShrub(Block.leavesThorn.id, Block.logOak.id);
         } else
         {
-            return new WorldFeatureTreeThorn(2, Block.logThorn.id, 0, Block.leavesCaatinga.id, 0);
+            return new WorldFeatureTreeThorn(4, Block.logThorn.id, 0, Block.leavesThorn.id, 0);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java b/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java
new file mode 100644
index 000000000..53940e9a1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeDesert.java
@@ -0,0 +1,23 @@
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
+
+import java.util.Random;
+
+public class BiomeDesert extends Biome
+{
+
+    public BiomeDesert(String key)
+    {
+        super(key);
+    }
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(Random random) {
+
+        return new WorldFeatureTreePalm(Block.logPalm, Block.leavesPalm, random.nextInt(10) == 0, false);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 450145efe..4c8e67595 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -16,7 +16,7 @@ public class Biomes
     public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("shrubland").setColor(0xbaba38));
     public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new Biome("desert").setColor(0xEDE26F).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm).setTopBlock(Block.sand.id).setFillerBlock(Block.sand.id));
+    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm).setTopBlock(Block.sand.id).setFillerBlock(Block.sand.id));
     public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
     public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Block.blockSnow.id).setFillerBlock(Block.blockSnow.id));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
@@ -28,8 +28,8 @@ public class Biomes
     public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Block.dirtScorched.id).setTopBlock(Block.dirtScorched.id));
     public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
     public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.grassScorched.id).setFillerBlock(Block.dirtScorched.id));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Block.grass.id).setFillerBlock(Block.dirt.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Block.grass.id).setFillerBlock(Block.dirt.id).setBlockedWeathers(Weather.overworldSnow));
     public static final Biome OVERWORLD_FOREST_DRY = register("minecraft:overworld.forest.dry", new BiomeDryForest("forest.dry").setColor(0x85c472));
 
     public static Biome register(String key, Biome biome)
diff --git a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index b836ee2f6..751cf0cbf 100644
--- a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -367,12 +367,6 @@ public final class BiomeProviderOverworld
         brm.addRange(Biomes.OVERWORLD_DESERT,
                 new BiomeRange(0.95, 1.0, 0.0, 0.1, 0.0, 1.0, 0.0, 1.0)
         );
-        brm.addRange(Biomes.OVERWORLD_OUTBACK,
-                new BiomeRange(0.75, 0.95, 0.0, 0.1, 0.0, 1.0, 0.15, 1.0)
-        );
-       brm.addRange(Biomes.OVERWORLD_OUTBACK_GRASSY,
-               new BiomeRange(0.75, 0.95, 0.0, 0.1, 0.0, 1.0, 0.0, 0.25)
-        );
 
         brm.addRange(Biomes.OVERWORLD_SEASONAL_FOREST,
                 new BiomeRange(0.5, 0.75, 0.4, 1.0, 0.0, 1.0, 0.0, 1.0)
@@ -385,16 +379,19 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.95, 1.0, 0.4, 0.85, 0.0, 1.0, 0.0, 1)
         );
         brm.addRange(Biomes.OVERWORLD_FOREST_DRY,
-                new BiomeRange(0.75, 0.95, 0.2, 0.4, 0.0, 1.0, 0.0, 0.95)
+                new BiomeRange(0.75, 1.0, 0.1, 0.4, 0.0, 1.0, 0.0, 1.0)
         );
-        brm.addRange(Biomes.OVERWORLD_CAATINGA,
-                new BiomeRange(0.95, 1.0, 0.1, 0.4, 0.0, 1.0, 0.0, 0.75)
+        brm.addRange(Biomes.OVERWORLD_OUTBACK,
+                new BiomeRange(0.98, 1.0, 0.1, 0.4, 0.0, 1.0, 0.0, 0.75)
         );
-        brm.addRange(Biomes.OVERWORLD_CAATINGA_PLAINS,
-                new BiomeRange(0.95, 1.0, 0.1, 0.4, 0.0, 1.0, 0.75, 1.0)
+        brm.addRange(Biomes.OVERWORLD_OUTBACK_GRASSY,
+                new BiomeRange(0.98, 1.0, 0.1, 0.4, 0.0, 1.0, 0.75, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_CAATINGA,
-                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.75, 0.95, 0.0, 0.1, 0.0, 1.0, 0.15, 1.0)
+        );
+        brm.addRange(Biomes.OVERWORLD_CAATINGA_PLAINS,
+                new BiomeRange(0.75, 0.95, 0.0, 0.1, 0.0, 1.0, 0.0, 0.25)
         );
         brm.addRange(Biomes.OVERWORLD_RAINFOREST,
                 new BiomeRange(0.95, 1.0, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
